#ifndef __UART_H__
#define __UART_H__

/* Global definitions */

#ifndef __IUART_H__
typedef unsigned char  U8;
typedef          char  S8;
typedef unsigned short U16;
typedef          short S16;
typedef unsigned long  U32;
typedef          long  S32;
#endif

/* UART Baud rate calculation */

#define UART_CPU               4000000      /* 4Mhz */
#define UART_BAUD_RATE         9600         /* baud rate*/
#define UART_BAUD_SELECT       (UART_CPU/(UART_BAUD_RATE*16l)-1)

//* LEDs */
unsigned char* LED  = (unsigned char*)0xF800;

/* Global functions */

extern void UART_Init();
extern void UART_SendByte(U8 Data);
extern U8   UART_ReceiveByte();
extern void UART_PrintfStr(S8* pBuf);
extern void UART_PrintfEndOfLine();
extern void UART_PrintfU8 (U8 Data);
extern void UART_PrintfU16(U16 Data);
extern void UART_PrintfU32(U32 Data);
extern void UART_sPrintfU8(U8 Data, U8* Str);
extern void UART_sPrintfU16(U16 Data, U8* Str);
extern void UART_sPrintfU32(U32 Data, U8* Str);

//
// polled uart routines
//

#define PPRINT(string)   UART_PrintfStr(string)
#define PEOL()           UART_PrintfEndOfLine()
#define PPRINTU8(data)   UART_PrintfU8(data)
#define PPRINTU16(data)  UART_PrintfU16(data)
#define PPRINTU32(data)  UART_PrintfU32(data)


//#define PPRINT(string)   
//#define PEOL()           
//#define PPRINTU8(data)   
//#define PPRINTU16(data)  
//#define PPRINTU32(data)  

//
// HDSL2 debug macros
//

#define HPRINT(string)   UART_PrintfStr(string)
#define HEOL()           UART_PrintfEndOfLine()
#define HPRINTU8(data)   UART_PrintfU8(data)
#define HPRINTU16(data)  UART_PrintfU16(data)
#define HPRINTU32(data)  UART_PrintfU32(data)

//#define HPRINT(string)   
//#define HEOL()           
//#define HPRINTU8(data)   
//#define HPRINTU16(data)  
//#define HPRINTU32(data)  

#endif
